<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Ead extends CI_Controller {

	/**
	 * Index Page for this controller.
	 *
	 * Maps to the following URL
	 * 		http://example.com/index.php/welcome
	 *	- or -
	 * 		http://example.com/index.php/welcome/index
	 *	- or -
	 * Since this controller is set as the default controller in
	 * config/routes.php, it's displayed at http://example.com/
	 *
	 * So any other public methods not prefixed with an underscore will
	 * map to /index.php/welcome/<method_name>
	 * @see https://codeigniter.com/user_guide/general/urls.html
	 */	

	public function __construct()
    {
        parent::__construct();        
        $this->load->helper(array('form', 'url'));
        $this->load->model("M_participante", "participante");
        $this->load->model("M_videos", "videos");
    }

	public function treinamento()
	{
		$dados = array("mensagem" => "Logado com sucesso!");		
		$this->load->helper('url');
		$this->load->view('cabecalho');        
		$this->load->view('treinamento');	
        $this->load->view('rodape');		
	}

	public function validarCNPJCliente(){
		$cnpj = $this->input->post("cnpj");		
		$sac = $this->input->post("sac");
		
		$result['erro'] = $this->participante->buscarStatusParticipanteNew($cnpj, 'WinSAE2FC');
		$status = $result['erro']['status'];		
				
		if ($status == 'A') {
			$this->session->set_userdata("logado", $result['erro']);
			if($sac == 'sac'){
				$this->load->view('/cabecalho');        		
				$this->load->view('/sacRetorno', $result);
				$this->load->view('/rodape');
			} else {
				redirect("ead/videos");				
			}			
		} else {			
			$dados['erro'] = "CNPJ não localizado na base de dados";			
			if($sac == 'sac'){				
				//redirect('/sac');
				echo '<h3>CNPJ não localizado na base de dados</h3><a href="/sac">Clique aqui para voltar</a>';
			} else {
				$this->load->view('treinamento', $dados['erro']);
			}			
		}
	}

	public function videos(){
		$this->load->helper('url');
		$this->load->view('cabecalho');        
		$this->load->view('videos');	
        $this->load->view('rodape');			
	}

	public function buscarVideos(){
			
		$result = $this->videos->buscarVideos($this->input->post('modulo'));
		$dados['erro'] = $result;
		// echo ($dados);
		foreach ($result as $row)
		{		
		$tabela = "";
		
        $tabela .= "<div class='col-lg-4'>";
        $tabela .= "<div class='embed-responsive embed-responsive-1by1'>"; 
        $tabela .= $row['LINK'];
        $tabela .= "</div>";
        $tabela .= "<h3>".utf8_encode($row['MODULO_DETALHE'])."</h3>"; 
        $tabela .= "<p>".utf8_encode($row['DESCRICAO'])."</p>";
        $tabela .= "</div>";			
		echo $tabela;
		}
	}
}
