<?php
defined('BASEPATH') OR exit('No direct script access allowed');

require_once 'vendor/autoload.php';

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;


use Comtele\Services\CreditService;
use Comtele\Services\TextMessageService;
use Comtele\Core\DeliveryStatus;


require APPPATH . 'libraries/REST_Controller.php';

require APPPATH . 'libraries/comtele/comtele_sdk/Comtele/Services/CreditService.php';

require APPPATH . 'libraries/PHPMailer/src/Exception.php';
require APPPATH . 'libraries/PHPMailer/src/PHPMailer.php';
require APPPATH . 'libraries/PHPMailer/src/SMTP.php';

const API_KEY = "d51d2a89-2cd6-463d-8fa1-628392ea8157";

class Restrito extends REST_Controller {

    function __construct()
    {
        // Construct the parent class
        header('Access-Control-Allow-Origin: *');
        header('Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept, Access-Control-Request-Method');
        header('Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE');
        $method = $_SERVER['REQUEST_METHOD'];
        if($method == 'OPTIONS') {
            die();
        }
				       
        parent::__construct();
        $this->load->library('boleto');
        $this->load->library('encryption');
        // $this->load->library('PDF');
        
        $this->load->model("M_participante", "participante");
        $this->load->model("M_usuario", "usuario");
        $this->load->model("M_util", "util");
        $this->load->model("M_estoque", "estoque");
        $this->load->model("M_cliente", "cliente");
        $this->load->model("M_condicao", "condicao");        
        $this->load->model("M_vendas", "vendas");
        $this->load->model("M_lojas", "lojas");
        $this->load->model("M_vendedores", "vendedores");
                
        $this->load->helper('download');
        ini_set('max_execution_time', 8000);
		
    }

    public function soap_get(){        
        $this->response("Alo Murilo");    
    }

    public function loginp_post(){  
        $nome = $this->post('usuario');                
        $consulta =   $this->usuario->validarLogin(strtoupper($nome), $this->post('senha'));
        
        if($consulta != false){
            $token = $this->util->token_get($consulta->NOME);
            $data = array(            
                'CODIGO' => $consulta->CODIGO,
                // 'SENHA' => $consulta->SENHA,
                'NOME' => $consulta->NOME,
                'GERENTE' => $consulta->GERENTE,
                'LOJA' => $consulta->LOJA,
                'STATUS' => $consulta->STATUS,
                'SENHA' => $consulta->SENHA,
                'DESCVENDA' => $consulta->DESCVENDA,
                'VENDEDOR' => $consulta->VENDEDOR,
                'TOKEN' => $token['token']
            );        
            $this->response($data);     
        } else {
            $this->response($consulta);     
        }
        
    }

    public function cadastrarProdutos_post(){
        if($this->post('token') != ""){
            $tokenDescrypt = $this->util->token_post($this->post('nome'), $this->post('token'));
            if($tokenDescrypt != false){
            $consulta = $this->estoque->buscarProdutos();
            $this->response($consulta);
            } else {
                $this->response(false);
            }
        } else {
             $this->response(false);
        }
    }

    public function consultarProdutosIndividual_post(){
        $jsonObj = $this->post();
        $nome = $jsonObj[0]['nome'];
        $token = $jsonObj[0]['token'];   
        if($token != ""){
            $tokenDescrypt = $this->util->token_post($nome, $token);
            if($tokenDescrypt != false){
                $consulta = $this->estoque->buscarProdutosIndividual(strtoupper($jsonObj[1]['PARAMETRO']));                
                $this->response($consulta);                
            } else {
                $this->response(false);
            }
        } else {
            $this->response(false);
        }
        
        // $this->response($consulta);        
    }

    public function buscarEstoqueIndividual_post(){
        $jsonObj = $this->post();
        $nome = $jsonObj[0]['nome'];
        $token = $jsonObj[0]['token'];   
        if($token != ""){
            $tokenDescrypt = $this->util->token_post($nome, $token);
            if($tokenDescrypt != false){
                $consulta = $this->estoque->buscarProdutosIndividual(strtoupper($jsonObj[1]['CODPROD']));                
                $this->response($consulta);                
            } else {
                $this->response(false);
            }
        } else {
            $this->response(false);
        }        
        // $this->response($consulta);        
    }

    public function cadastrarClientes_post(){
        // $this->response($this->post());
        $jsonObj = $this->post();
        // $this->response($jsonObj);
        $nome = $jsonObj[0]['nome'];
        $token = $jsonObj[0]['token']; 
        $cliente = $jsonObj[1]['NOME']; 
        $vendedor = $jsonObj[1]['VENDEDOR']; 
        if($token != ""){
            $tokenDescrypt = $this->util->token_post($nome, $token);
            if($tokenDescrypt != false){
                $consulta = $this->cliente->buscarClientes(strtoupper($cliente), $vendedor);
                $this->response($consulta);
            } else {
                $this->response(false);
            }
        } else {
             $this->response(false);
        }   
    }

    public function consultarSaldoClientes_post(){
        $jsonObj = $this->post();

        $nome = $jsonObj[0]['nome'];
        $token = $jsonObj[0]['token'];         
        $vendedor = $jsonObj[1]['VENDEDOR']; 
        if($token != ""){
            $tokenDescrypt = $this->util->token_post($nome, $token);
            if($tokenDescrypt != false){
                $dataAtual = date('Y-m-d');
                $consulta = $this->cliente->atualizarContasClientes($dataAtual, $vendedor);
                $this->response($consulta);
            } else {
                $this->response(false);
            }
        } else {
             $this->response(false);
        }
    }

    public function cadastrarCondicao_post(){
        if($this->post('token') != ""){
            $tokenDescrypt = $this->util->token_post($this->post('nome'), $this->post('token'));
            if($tokenDescrypt != false){
                $consulta = $this->condicao->buscarCondicao();
                $this->response($consulta);
            } else {
                $this->response(false);
            }
        } else {
             $this->response(false);
        }   
    }

    public function cadastrarTipoDocumento_post(){
        if($this->post('token') != ""){
            $tokenDescrypt = $this->util->token_post($this->post('nome'), $this->post('token'));
            if($tokenDescrypt != false){
                $consulta = $this->condicao->buscarTipoDocumento();
                $this->response($consulta);
            } else {
                $this->response(false);
            }
        } else {
             $this->response(false);
        }
        
    }

    public function validarLogin_post(){
        $tokenDescrypt = $this->util->token_post($this->post('nome'), $this->post('token'));
        $this->response($tokenDescrypt);   
    }
	
	public function consultarSMS_post(){
		$cnpj = $this->post('cnpjCpf');
		
		$idMsgPrincipal = "";		
		
		$delivered = [];
		$msgDelivered = "";
		
		$undelivered = [];
		$msgUndelivered = "";
		
		$rejected = [];
		$msgRejected = "";
		
		$expired = [];
		$msgExpired = "";
		
		$accepted = [];
		$msgAccepted = "";
		
		$dados = $this->participante->buscarStatusParticipanteNew($cnpj, 'WinSAE2FC');
		$grupoCliente = $dados['grupo'];
		$idGrupoCliente = $dados['id_grupo'];
		$saldoGrupo = $dados['saldoSMS'];
		
		$textMessageService = new TextMessageService(API_KEY);
		$dia = $this->post('dataInicial');
		$diaFinal = $this->post('dataFinal');
		// $arRetorno = $this->participante->retornoSMSStatus();
		$retorno = $textMessageService->get_detailed_report($dia, $diaFinal, DeliveryStatus::All);
		
		if($retorno == null){
			$this->response(array(
			'grupo' => $grupoCliente,
			'saldoSMS' => $saldoGrupo,
			'Success' => false,
			'Object' => [],
			'Message' => 'Tente consultar daqui 10 segundos'
			));
		}
		$arrayResultadoSMS = $retorno->Object;
		$arr = array();		
		
		$delivered = [];
		$undelivered = [];
		$rejected = [];
		$expired = [];
		$accepted = [];
		
		for($i = 0; $i < count($arrayResultadoSMS); $i++) {
			$telefone = substr(substr($arrayResultadoSMS[$i]->Receiver, 2), 0, 11);
			$idMsg = explode("_", $arrayResultadoSMS[$i]->Sender);
			$statusMsg = $arrayResultadoSMS[$i]->DlrStatus;			
			$msgRetorno = $arrayResultadoSMS[$i]->SystemMessage;			
			if($idMsg[0] == $cnpj){
				$idMsgPrincipal = $idMsg[1];
				if($statusMsg == 'Delivered'){
					array_push($delivered, $telefone);
					$msgDelivered = $msgRetorno;
				}
				if($statusMsg == 'Undelivered'){
					array_push($undelivered, $telefone);
					$msgUndelivered = $msgRetorno;
				}
				if($statusMsg == 'Rejected'){
					array_push($rejected, $telefone);
					$msgRejected = $msgRetorno;
				}
				if($statusMsg == 'Expired'){
					array_push($expired, $telefone);
					$msgExpired = $msgRetorno;
				}
				if($statusMsg == 'Accepted'){
					array_push($accepted, $telefone);
					$msgAccepted = $msgRetorno;
				}
				array_push($arr, array(
					"Receiver" => substr(substr($arrayResultadoSMS[$i]->Receiver, 2), 0, 11),
					"Content" => $arrayResultadoSMS[$i]->Content,
					"Status" => $arrayResultadoSMS[$i]->Status,
					"ScheduleDate" => $arrayResultadoSMS[$i]->ScheduleDate,
					"RequestDate" => $arrayResultadoSMS[$i]->RequestDate,
					"SystemMessage" => $arrayResultadoSMS[$i]->SystemMessage,
					"DlrStatus" => $arrayResultadoSMS[$i]->DlrStatus,
					"Sender" => $arrayResultadoSMS[$i]->Sender)
				);
			}							
        }
		
		$resultadoFinal = array(
			'grupo' => $grupoCliente,
			'saldoSMS' => $saldoGrupo,
			'Success' => $retorno->Success,
			'Object' => $arr,
			'Message' => $retorno->Message
		);
      	// $this->response($resultadoFinal, REST_Controller::HTTP_OK);
		if(count($delivered) > 0){
			$let = array_chunk($delivered, 1000);
			for($i = 0; $i < count($let); $i++) {
				$let[$i];
				$abc = $this->participante->updateSMS($idGrupoCliente, $idMsgPrincipal, 1, $cnpj, 'Delivered', $msgDelivered, implode("','", $let[$i]));
			}
		}
		if(count($undelivered) > 0){
			$let = array_chunk($undelivered, 1000);
			for($i = 0; $i < count($let); $i++) {
				$let[$i];
				$abc = $this->participante->updateSMS($idGrupoCliente, $idMsgPrincipal, 0, $cnpj, 'Undelivered', $msgUndelivered, implode("','", $let[$i]));
			}
		}
		if(count($rejected) > 0){
			$let = array_chunk($rejected, 1000);
			for($i = 0; $i < count($let); $i++) {
				$let[$i];
				$abc = $this->participante->updateSMS($idGrupoCliente, $idMsgPrincipal, 0, $cnpj, 'Rejected', $msgRejected, implode("','", $let[$i]));
			}
		}
		if(count($expired) > 0){
			$let = array_chunk($expired, 1000);
			for($i = 0; $i < count($let); $i++) {
				$let[$i];
				$abc = $this->participante->updateSMS($idGrupoCliente, $idMsgPrincipal, 0, $cnpj, 'Expired', $msgExpired, implode("','", $let[$i]));
			}
		}
		if(count($accepted) > 0){
			$let = array_chunk($accepted, 1000);
			for($i = 0; $i < count($let); $i++) {
				$let[$i];
				$abc = $this->participante->updateSMS($idGrupoCliente, $idMsgPrincipal, 0, $cnpj, 'Accepted', $msgAccepted, implode("','", $let[$i]));				
			}
		}
		
		$this->response($resultadoFinal, REST_Controller::HTTP_OK);
	}
	
	public function enviarSMS_post(){
		$cnpj = $this->post('cnpjCpf');
		$dados = $this->participante->buscarStatusParticipanteNew($cnpj, 'WinSAE2FC');
		$grupoCliente = $dados['grupo'];
		$idGrupoCliente = $dados['id_grupo'];
		$saldoGrupo = $dados['saldoSMS'];
		$clientes = $this->post('clientes');
      	$let = array_chunk($clientes, 200);
      	$insertA = "";
      	$msg = $this->post('msg');
		$idMsg = $this->post('idMsg');
      	$dataEnvio = new DateTime();
      	for($a = 0; $a < count($let); $a++){
          	$ap = $let[$a];          	
          	for($y = 0; $y < count($ap); $y++){              	
            	$insertA .= "INSERT INTO ENVIOSMS (IDGRUPO, IDMSG, DATAENVIO, TELEFONE, ENVIADO, CNPJ) VALUES (".$idGrupoCliente.", ".$idMsg.", '".$dataEnvio->format('d.m.Y')."', '".$ap[$y]['telefone']."', 1, '".$cnpj."'); ". PHP_EOL;
            }
          $ar = $this->participante->inserirSMSNEW('EXECUTE BLOCK AS BEGIN '. PHP_EOL .$insertA.' END');
          $insertA = "";          	
        }
		$arr = array();
      	$arr2 = [];
		$insert = "";
		for($i = 0; $i < count($clientes); $i++) {
			array_push($arr, $clientes[$i]['telefone'] );          	
        }
		$textMessageService = new TextMessageService(API_KEY);
		$retorno = $textMessageService->send($cnpj.'_'.$idMsg, $msg, $arr);
      	//$retorno = $this->send($cnpj.'_'.$idMsg, $msg, $arr);
		$caminho = "/var/www/webroot/tecnodata/assets/";
      	      	
 	  	$fp = fopen($caminho.'netshoes.txt', 'w');
	  	$str = "";  	  
      	$str .= 'arquivo completoA: ' . var_export($retorno, true) . PHP_EOL;            	
      	$str .= 'arquivo completo: ' . var_export($arr, true) . PHP_EOL; 
      
  	  	fwrite($fp, $str);
  	  	fclose($fp);
		$arr = array(
			'grupo' => $grupoCliente,
			'saldoSMS' => $saldoGrupo-count($clientes),
			'Success' => $retorno->Success,
			'Object' => $retorno->Object,
			'Message' => $retorno->Message
		);
		
		if($retorno){
			$this->response($arr, REST_Controller::HTTP_OK); // OK (200) being the HTTP response code*/
		} else {
			$this->response([
				'status' => FALSE,
                'message' => 'Página não encontrada.'
            ], REST_Controller::HTTP_NOT_FOUND); // NOT_FOUND (404) being the HTTP response code
		}		
	}
  
  	public function send($sender, $content, $receivers)
    {
        $service_url = "https://sms.comtele.com.br/api/v2/" . "send";
        $payload = [
            "Sender" => $sender,
            "Content" => $content,
            "Receivers" => implode(",", $receivers),
        ];

        $headers = [
            "Content-Type: application/json",
            "Content-Length: " . strlen(json_encode($payload)),
            "auth-key:" . API_KEY,
        ];
		$caminho = "/var/www/webroot/tecnodata/assets/";
      	      	
 	  	$fp = fopen($caminho.'aaanetshoes.txt', 'w');
	  	$str = "";
      	$str .= 'arquivo completo: ' . var_export($payload, true) . PHP_EOL; 
      
  	  	fwrite($fp, $str);
  	  	fclose($fp);
      
        $curl = curl_init($service_url);
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($payload));

        $server_output = curl_exec($curl);
        curl_close($curl);

        return json_decode($server_output);
    }
	
	public function saldoSMS_post(){
				
		// $textMensagem = new CreditService(API_KEY);
		// $result = $textMensagem->get_my_credits();
		
		// $this->response($result);
		
		$cnpj = $this->post('cnpjCpf');
		$nomePrograma = $this->post('programa');
		$consulta = $this->participante->buscarStatusParticipanteNew($cnpj, $nomePrograma);		
		if($consulta){
			$this->response($consulta, REST_Controller::HTTP_OK); // OK (200) being the HTTP response code*/
		} else {
			$this->response([
				'status' => FALSE,
                'message' => 'Página não encontrada.'
            ], REST_Controller::HTTP_NOT_FOUND); // NOT_FOUND (404) being the HTTP response code
		}		
	}
	
	public function buscarCnpjCpfNew_get(){
		$cnpj = $this->get('cnpjCpf');
		$nomePrograma = $this->get('programa');
		$consulta = $this->participante->buscarStatusParticipanteNew($cnpj, $nomePrograma);		
		$this->response($consulta, REST_Controller::HTTP_OK); // OK (200) being the HTTP response code
	}
  
  	public function buscarCnpjCpfNewT_get(){
		$cnpj = $this->get('cnpjCpf');
		$nomePrograma = $this->get('programa');
      $this->response('OK', REST_Controller::HTTP_OK);
		$consulta = $this->participante->buscarStatusParticipanteNewTeste($cnpj, $nomePrograma);		
		$this->response($consulta, REST_Controller::HTTP_OK); // OK (200) being the HTTP response code
	}
  
  

    public function buscarCnpjCpf_get(){
        $consulta = $this->participante->buscarStatusParticipante($this->get('cnpjCpf'));
        if ($consulta){                
                $this->response($consulta, REST_Controller::HTTP_OK); // OK (200) being the HTTP response code
        } else {               
            $this->response([
				'status' => FALSE,
                'message' => 'No users were found'
            ], REST_Controller::HTTP_NOT_FOUND); // NOT_FOUND (404) being the HTTP response code
        }
    }

    public function saveCliente_post() { 
        $jsonObj = $this->post();
        //$this->response($jsonObj);    
        $nome = $jsonObj[0]['nome'];
        $token = $jsonObj[0]['token'];   
        if($token != ""){
            $tokenDescrypt = $this->util->token_post($nome, $token);
            if($tokenDescrypt != false){
                if($this->cliente->consultaClienteCpf($jsonObj[1]['CPF']) == [null]){
                    $idCliente = $this->cliente->insertCliente($jsonObj[1]['CPF'], $jsonObj[1]['NOME'], $jsonObj[1]['CEP'],
                    $jsonObj[1]['UF'], $jsonObj[1]['CIDADE'], $jsonObj[1]['ENDERECO'], $jsonObj[1]['BAIRRO'], $jsonObj[1]['TELEFONE'], $jsonObj[1]['EMAIL'],
                    $jsonObj[1]['IBGE'] );                                
                    $this->response($idCliente);                
                } else {
                    $this->response(false);    
                }
            } else {
                $this->response(false);
            }
        } else {
            $this->response(false);
        }
    }

    public function inserirCabecalho_post(){
        $dataAtual = (date('d-m-Y'));                    
        $jsonObj = $this->post();
        $nome = $jsonObj[0]['nome'];
        $token = $jsonObj[0]['token'];   
        if($token != ""){
            $tokenDescrypt = $this->util->token_post($nome, $token);
            if($tokenDescrypt != false){
                $pedido = $this->util->geraNumeroPedido($dataAtual, $jsonObj[1]['LOJA']);      
                $status = $this->vendas->inserirCabecalho($pedido, date('Y-m-d'), $jsonObj[1]['LOJA'], $jsonObj[1]['VALOR'], 
                    $this->util->zeroEsquerda($jsonObj[1]['CODCLIE'], 6), $jsonObj[1]['CONDICAO'], 
                    $jsonObj[1]['VENDEDOR'], $jsonObj[1]['OBS'], $jsonObj[1]['CODAREA']);
                $this->response($pedido);               
            } else {
                $this->response(false);
            }
        } else {
            $this->response(false);
        }
    }

    public function inserirMovimento_post(){
        $dataAtual = (date('d-m-Y'));                    
        $jsonObj = $this->post();
        $nome = $jsonObj[0]['nome'];
        $token = $jsonObj[0]['token'];   
        if($token != ""){
            $tokenDescrypt = $this->util->token_post($nome, $token);
            if($tokenDescrypt != false){  
                $status = $this->vendas->inserirItens($jsonObj[1]['PEDIDO'], date('Y-m-d'), $jsonObj[1]['LOJA'], $jsonObj[1]['VALOR'], $jsonObj[1]['CODPROD'], $jsonObj[1]['NUMERO'], $jsonObj[1]['QUANTIDADE'], $jsonObj[1]['CUSTO'], $jsonObj[1]['VALOR_BRUTO']);
                $this->response($status);               
            } else {
                $this->response(false);
            }
        } else {
            $this->response(false);
        }
    }

    public function deletarItensMovimento_post() { 
        $jsonObj = $this->post();
        $nome = $jsonObj[0]['nome'];
        $token = $jsonObj[0]['token'];   
        if($token != ""){
            $tokenDescrypt = $this->util->token_post($nome, $token);
            if($tokenDescrypt != false){  
                $consulta =  $this->vendas->deletarItens($jsonObj[1]['PEDIDO'], $jsonObj[1]['CODPROD'], $jsonObj[1]['NUMERO']);
                $this->response($consulta);               
            } else {
                $this->response(false);
            }
        } else {
            $this->response(false);
        } 
    }

    public function atualizarPedido_post(){
        $jsonObj = $this->post();
        $nome = $jsonObj[0]['nome'];
        $token = $jsonObj[0]['token'];   
        if($token != ""){
            $tokenDescrypt = $this->util->token_post($nome, $token);
            if($tokenDescrypt != false){  
                $consulta =  $this->vendas->atualizarPedi01($jsonObj[1]['PEDIDO'], $jsonObj[1]['VALOR'], $jsonObj[1]['CONDICAO'], $jsonObj[1]['CODAREA'], $jsonObj[1]['OBS'], $jsonObj[1]['TPG']);
                $condicaoPagto = $this->condicao->buscarCondicaoPagamento($jsonObj[1]['CONDICAO'], $jsonObj[1]['CODAREA']);
                $valorParcela = $jsonObj[1]['VALOR'] / $condicaoPagto[0]['PAGTO'];
                $arr = array();
                if($condicaoPagto[0]['PAGTO'] > 16){
                    $this->vendas->inserirContasReceberFinal($jsonObj[1]['PEDIDO'], "1", date('Y-m-d'), $jsonObj[1]['LOJA'], $jsonObj[1]['VALOR'], $jsonObj[1]['CODCLIE'], date('Y-m-d'), $jsonObj[1]['TPG'] );
                    $this->response(true);
                } else {                    
                    for($i = 0; $i < $condicaoPagto[0]['PAGTO']; $i++) {
                        $cont = 'INT'.(+1+$i);
                        $this->vendas->inserirContasReceberFinal($jsonObj[1]['PEDIDO'], (+1+$i), date('Y-m-d'), $jsonObj[1]['LOJA'], $valorParcela, $jsonObj[1]['CODCLIE'], date('Y-m-d', strtotime('+'.$condicaoPagto[0][$cont].' days', strtotime((date('Y-m-d'))))), $jsonObj[1]['TPG']);
                    }
                    $this->response(true);  
                }                                
            } else {
                $this->response(false);
            }
        } else {
            $this->response(false);
        } 
    }

    public function testeEmail_post(){        
        $valor = "R$10,20";
        $vencimento = "10/02/2009";
        $f=fopen("c://winsae//tabela.txt","a+",0);
        $linha=$valor.":".$vencimento.":\n";
        fwrite($f,$linha,strlen($linha));
        fclose($f);
        //$vendedores = $this->vendedores->buscarVendedorUsuario("0001");        
        //$arr = array("LOJA" => "murilo789@hotmail.com", "CLIENTE" => "", "VENDEDOR" => $vendedores->EMAIL);
        //$this->response($arr);
        // $this->response($arr['LOJA']);
    }

    public function enviarEmail($email, $mensagem, $nome, $pedido) {
        $mail = new PHPMailer();
        $mail->IsSMTP(); //Definimos que usaremos o protocolo SMTP para envio.
        $mail->SMTPAuth = true; //Habilitamos a autenticação do SMTP. (true ou false)
        $mail->SMTPSecure = "ssl"; //Estabelecemos qual protocolo de segurança será usado.
        $mail->Host = "smtp.gmail.com"; //Podemos usar o servidor do gMail para enviar.
        $mail->Port = 465; //Estabelecemos a porta utilizada pelo servidor do gMail.
        $mail->Username = "sistemawinsae@gmail.com"; //Usuário do gMail
        $mail->Password = "tec32852193"; //Senha do gMail
        $mail->SetFrom('suporte@tecnodataonline.com.br', 'Tecnodata Tecnologia da Informação'); //Quem está enviando o e-mail.
        $mail->AddReplyTo('suporte@tecnodataonline.com.br', $nome); //Para quem a resposta será enviada.
        $mail->Subject = "Vendas - Pedido: ".$pedido; //Assunto do e-mail.
        $mail->Body = $mensagem;
        $mail->AltBody = "1234";
        $destino = $email['CLIENTE'];
        $mail->AddAddress($destino, $nome); // CLIENTE
        $mail->AddAddress($email['VENDEDOR'], "Vendedor"); // VENDEDOR 
        $mail->AddAddress($email['LOJA'], "Loja"); // LOJA
        if(!$mail->Send()) {
            $data = "ocorreu um erro durante o envio: " . $mail->ErrorInfo;
        } else {
            $data = "Mensagem enviada com sucesso!";
        }
        return $data;
    }

    public function salvar_post(){
        $consulta = $this->estoque->buscarFotosProdutos();
        $this->response($consulta);
    }

    public function salvarClientesCCA_post(){
        $consulta = $this->cliente->buscarClienteCCA($this->post('NOME'));
        if($consulta == []){
            $consulta = $this->cliente->insertClienteCCA($this->post('NOME'), $this->post('PERCENTUAL'));
        } else {
            $consulta = $this->cliente->atualizarClienteCCA($this->post('NOME'), $this->post('PERCENTUAL'));
        }
        $this->response($consulta);
    }

    public function buscarClienteCCA_post(){
        $consulta = $this->cliente->buscarClienteCCA($this->post('NOME'));
        $this->response($consulta);
    }

    public function buscarLoginCCA_post(){
        $consulta = $this->usuario->buscarLoginCCA($this->post('NOME'));                    
        $this->response($consulta);
        
    }

    public function buscarLogoTipoEmpresa_post(){
        $consulta = $this->lojas->buscarLogoEmpresa();                    
        $this->response($consulta);
    }

    public function buscarTodosParticipantes_post(){
        $consulta = $this->participante->buscarTodosParticipantes();                    
        $this->response($consulta);
    }

    public function buscarTodosGruposParticipantes_post(){
        $consulta = $this->participante->buscarGruposParticipantes();                    
        $this->response($consulta);
    }    

    public function insertParticipantes_post(){
        $nome = $this->util->retirarAcentos($this->post('NOME'));
        $cpfcnpj = $this->post('CPF');
        $uf = $this->post('UF');
        $cidade = $this->util->retirarAcentos($this->post('CIDADE'));  
        $cep = str_replace('-','',str_replace('.','',$this->post('CEP')));
        $endereco = $this->post('ENDERECO');
        $email = $this->post('EMAIL');
        $idGrupo = $this->post('IDGRUPO');
        
        $telefone = str_replace('-','',str_replace(' ','',str_replace(')','',str_replace('(','', $this->post('TELEFONE')))));
        $dataInativacao = null;
        $motivoInativacao = null;                  
        $consulta = $this->participante->inserirParticipante(strtoupper($nome), $cpfcnpj, strtoupper($uf), strtoupper($cidade), $cep, strtoupper($endereco), strtoupper($email), $idGrupo, $telefone, $dataInativacao, $motivoInativacao);
        $mensagem = "<p>O cliente ".$this->post('NOME')." se filiou a Tecnodata TI.</p>";
        $mensagem .= "<p>CNPJ: ".$cpfcnpj."</p>";
        $mensagem .= "<p>UF: ".$uf." - Cidade: ".$cidade."</p>";
        $mensagem .= "<p>Grupo: ".$this->post('GRUPO')."</p>";
        $mensagem .= "<br><br><p>Mensagem gerada automaticamente pelo sistema de gestão da Tecnodata</p>";
        $this->enviarEmail("tecnodata@tecnodataonline.com.br", $mensagem, $nome, $cpfcnpj);
        $this->response($consulta);
    }

    public function acaoParticipantes_post(){
        $jsonObj = $this->post();        
        $id = $jsonObj[0]['ID'];
        $motivo = $jsonObj[1]['MOTIVO'];   
        if($motivo != ""){
            $consulta = $this->participante->inativarParticipante($id, $this->util->retirarAcentos(strtoupper($motivo)));
        } else {
            $consulta = $this->participante->ativarParticipante($id);
        }
		$participante = $this->buscarParticipanteID($id);
        $this->response($consulta);
    }

    public function loginTecnodata_post(){  
        $nome = $this->post('usuario');        
        $consulta =   $this->usuario->validarLoginTecnodata(strtoupper($nome), $this->post('senha'));        
        //$this->response($consulta); 
        if($consulta != false){
            $token = $this->util->token_get($consulta->NOME);
            $data = array(            
                'CODIGO' => $consulta->ID,
                'NOME' => $consulta->NOME,                
                'SENHA' => $consulta->SENHA,
                'TOKEN' => $token['token']
            );        
            $this->response($data);     
        } else {
            $this->response($consulta);     
        }
        
    }

    public function vendasPorVendedor_post(){
        $jsonObj = $this->post();
        $nome = $jsonObj[0]['nome'];
        $token = $jsonObj[0]['token'];         
        if($token != ""){
            $tokenDescrypt = $this->util->token_post($nome, $token);
            if($tokenDescrypt != false){

                $data_inicial = $this->util->converterData($jsonObj[1]['data_inicial']);
                $data_final = $this->util->converterData($jsonObj[1]['data_final']);
                $vendedor = ($jsonObj[1]['vendedor']);
                
                $consulta = $this->vendas->vendasPorCliente($data_inicial, $data_final, $vendedor);                    
                $this->response($consulta);
            } else {
                $this->response(false);
            }
        } else {
            $this->response(false);
        }   


        // {DATA: "2017-08-20", FINAL: "2018-08-20"}
        
    }       

    public function inserirParticipante_post(){        
        $consulta = $this->participante->inserirParticipante($this->post('nome'), $this->post('cpfcnpj'), $this->post('uf'),
            $this->post('cidade'), $this->post('cep'), $this->post('endereco'), $this->post('email'), $this->post('idGrupo'), 
            $this->post('telefone'), $this->post('dataInativacao'), $this->post('motivoInativacao'));
        $this->response($consulta);
    }

    public function inativarParticipante_post(){        
        $consulta = $this->participante->inativarParticipante($this->post('codigo_participante'), $this->post('motivoInativacao'));
        $this->response($consulta);
    }

    public function ativarParticipante_post(){
        $consulta = $this->participante->ativarParticipante($this->post('codigo_participante'));
        $this->response($consulta);
    }

    public function lerArquivosPasta_get(){

        // $path = "/var/www/webroot/Downloads/";
        // $path = "C:\\xampp\\htdocs";
        $path = "C:\\xampp\\htdocs\\Downloads\\";
        $diretorio = dir($path);
        $arr = array();         
        while($arquivo = $diretorio->read()){
            array_push($arr, array(            
                $arquivo
            )); 
        }
        $diretorio -> close();
        
        $this->response($arr);
    }

    public function baixarArquivo_get(){
		/*echo '<h1>Alo mundo!</h1>';*/
       
        // $path = "/var/www/webroot/Downloads/";
        $path = "C:\\xampp\\htdocs\\Downloads\\";
        $nomeArquivo = $this->get('nome');
        $data = file_get_contents ( $path.$nomeArquivo );
        echo force_download($path.$nomeArquivo, NULL);
    }

    public function buscarContasTecnodata_get(){
        //$this->get()
        $consulta = $this->participante->buscarContas(
            $this->util->converterData($this->get('dataInicial')), 
            $this->util->converterData($this->get('dataFinal'))
        );  
        //$this->response();
        $name = 'c://ACBrMonitorPLUS//saida//';
        for ($i=0; $i < count($consulta); $i++) { 
            if($consulta[$i]['STATUS'] == ""){

                if (file_exists($name.substr(str_replace("-","_",$consulta[$i]['DATAVENCI']), 0,10)."_".str_replace(" ","_",$consulta[$i]['FANTASIA'])."BOLETO_-resp.txt")) {
                    $f = fopen($name.substr(str_replace("-","_",$consulta[$i]['DATAVENCI']), 0,10)."_".str_replace(" ","_",$consulta[$i]['FANTASIA'])."BOLETO_-resp.txt", 'r');
                    $linha = "";
                    while(!feof($f)){
                        $linha .= fgets($f, 1024);
                    }                
                    fclose($f);
                    $consulta[$i]['STATUS'] = $linha;
                    // $this->participante->statusContas($consulta[$i]['PEDIDO'], trim($linha));
                }                 
            }            
        }        
        $this->response($consulta);
    }

    public function gerarBoletosParaClientes_post(){
        $name = 'c://ACBrMonitorPLUS//entrada//';                           
        $jsonObj = $this->post();
        $array = $jsonObj['baixaAutomatica'];
        
        
        
        for ($i=0; $i < count($array); $i++) { 
            
            $j = $array[$i]['PEDIDO'];            
            $grupoGeral = str_replace("_"," ", substr($j,11));
            $diaMesAno = $this->util->converterData(str_replace("_","-", substr($j,0,10)));            

            $conteudo = "BOLETO.LimparLista()";        
            $f = fopen($name.$array[$i]['PEDIDO']."_limparLista.txt", 'a+');            
            fwrite($f, $conteudo); 
            fclose($f);
            sleep(1);

            $imp = "BOLETO.SetDiretorioArquivo(C:\ACBrMonitorPLUS\boletos\,".$array[$i]['PEDIDO'].".PDF)";
            $f = fopen($name.$array[$i]['PEDIDO']."CONFIG_IMP_.txt", 'a+');
            fwrite($f, $imp); 
            fclose($f);
            
            $retorno = $this->participante->buscarContasPorID($diaMesAno, $grupoGeral);
            
            for ($a=0; $a < count($retorno); $a++) { 
                // $this->response($retorno[$a]);
                $conteudo = $this->util->gerarBoleto($retorno[$a]);
                $f = fopen($name.$array[$i]['PEDIDO']."BOLETO_.txt", 'a+');
                fwrite($f, $conteudo); 
                fclose($f);
                sleep(2);
            }
                
            $imp = "BOLETO.GerarPDF()";
            $f = fopen($name.$array[$i]['PEDIDO']."IMP_.txt", 'a+');
            fwrite($f, $imp); 
            fclose($f);
                
            $remessa = "BOLETO.GerarRemessa(c:\\remessa\)";
            $f = fopen($name.$i."__remessa.txt", 'a+');
            fwrite($f, $remessa); 
            fclose($f);

            sleep(1);
        }   
        $this->response(count($array));
    }

    public function verificarSeArquivoExiste($caminho){
        $status = false;
        if (file_exists($caminho)) {
            // $this->response($name.$nomeArquivo.".PDF");$
            $status = true;
            return $status;
        } else {
            return $status;
        }
    }
    
    public function baixarBoletoClientes_get(){
        $name = 'c:\\ACBrMonitorPLUS\\boletos\\';

        $nomeArquivo = str_replace('%27','',$this->get("pedido"));
        if (file_exists($name.$nomeArquivo.".PDF")) {
            // $this->response($name.$nomeArquivo.".PDF");
            $data = file_get_contents ( $name.$nomeArquivo.".PDF" );
            force_download($name.$nomeArquivo.".PDF", $data);
        }        
    } 

    public function gerarContasReceber_post(){
        // inserirContas($id, $vencimento, $valores)
        $array = $this->post();
        $ano = date("Y");
        $mes = date("m");                
        for ($i=0; $i < count($array['valores']); $i++) { 
            $dia = $this->util->zeroEsquerda($array['valores'][$i]['DIA_VENCIMENTO'], 2);
            if($ano == 2018 && (int)$array['valores'][$i]['MES'] == 1){
                $ano = $ano+1;
            }
            
            $data = mktime(00,00,00,(int)$array['valores'][$i]['MES'], (int)$dia, $ano);
            
            $venci = date('Y-m-d', $data);
            // date('Y-m-d', strtotime("+".$cont." month", ($data)));
            
            $this->participante->atualizarValoresParticipante(
                $array['valores'][$i]['ID'], 
                (double)$array['valores'][$i]['VL_PARCELAS'], 
                $dia
            );
            // $this->response($venci);
            $this->participante->inserirContas(
                $array['valores'][$i]['ID'], 
                $venci, 
                (double)$array['valores'][$i]['VL_PARCELAS']);            
        }        
        $this->response(true);
    }

    public function enviarEmailTecnodata($email, $mensagem, $nome, $assunto) {
        $mail = new PHPMailer();
        $mail->IsSMTP(); //Definimos que usaremos o protocolo SMTP para envio.
        $mail->SMTPAuth = true; //Habilitamos a autenticação do SMTP. (true ou false)
        $mail->SMTPSecure = "ssl"; //Estabelecemos qual protocolo de segurança será usado.
        $mail->Host = "smtp.gmail.com"; //Podemos usar o servidor do gMail para enviar.
        $mail->Port = 465; //Estabelecemos a porta utilizada pelo servidor do gMail.
        $mail->Username = "sistemawinsae@gmail.com"; //Usuário do gMail
        $mail->Password = "tec32852193"; //Senha do gMail
        $mail->SetFrom('suporte@tecnodataonline.com.br', 'Tecnodata Tecnologia da Informação'); //Quem está enviando o e-mail.
        $mail->AddReplyTo('suporte@tecnodataonline.com.br', $nome); //Para quem a resposta será enviada.
        $mail->Subject = $assunto; //Assunto do e-mail.
        $mail->Body = $mensagem;
        $mail->AltBody = "1234";
        $destino = $email;
		$mail->IsHTML(true);
        $mail->AddAddress($destino, $nome); // CLIENTE        
        if(!$mail->Send()) {
            $data = "ocorreu um erro durante o envio: " . $mail->ErrorInfo;
        } else {
            $data = "Mensagem enviada com sucesso!";
        }
        return $data;
    }

    //     public function enviarEmail($email, $mensagem, $nome, $assunto) {
    public function enviarEmailClientes_post(){
        $retorno = $this->enviarEmailTecnodata("suporte@tecnodataonline.com.br", 
            $this->post('post')['texto'], 
            "Murilo", 
            $this->post('post')['assunto']);
        $this->response($retorno);
    }
    
    public function testa_get(){
        
        $mail = new PHPMailer();
        $mail->IsSMTP(); //Definimos que usaremos o protocolo SMTP para envio.
        $mail->SMTPAuth = true; //Habilitamos a autenticação do SMTP. (true ou false)
        $mail->SMTPSecure = "ssl"; //Estabelecemos qual protocolo de segurança será usado.
        $mail->Host = "smtp.gmail.com"; //Podemos usar o servidor do gMail para enviar.
        $mail->Port = 465; //Estabelecemos a porta utilizada pelo servidor do gMail.
        $mail->Username = "sistemawinsae@gmail.com"; //Usuário do gMail
        $mail->Password = "tec32852193"; //Senha do gMail
        $mail->SetFrom('suporte@tecnodataonline.com.br', 'Tecnodata Tecnologia da Informação'); //Quem está enviando o e-mail.
        $mail->AddReplyTo('suporte@tecnodataonline.com.br', 'murilo'); //Para quem a resposta será enviada.
        $mail->Subject = 'Assunto do e-mail.';
        $mail->Body = '$mensagem';
        $mail->AltBody = "1234";
        $destino = 'murilo789@hotmail.com';
        $mail->AddAddress($destino, 'murilo'); // CLIENTE        
        if(!$mail->Send()) {
            $data = "ocorreu um erro durante o envio: " . $mail->ErrorInfo;
            $this->response($data);
        } else {
            $data = "Mensagem enviada com sucesso!";
            $this->response($data);
        }
        return $data;
        $this->response($data);
    }
}












