<?php
defined('BASEPATH') OR exit('No direct script access allowed');


// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . 'libraries/REST_Controller.php';

/**
 * This is an example of a few basic user interaction methods you could use
 * all done with a hardcoded array
 *
 * @package         CodeIgniter
 * @subpackage      Rest Server
 * @category        Controller
 * @author          Phil Sturgeon, Chris Kacerguis
 * @license         MIT
 * @link            https://github.com/chriskacerguis/codeigniter-restserver
 */
class Rest extends REST_Controller {

    function __construct()
    {
        // Construct the parent class
		header('Access-Control-Allow-Origin: *');
		header('Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept, Access-Control-Request-Method');
		header('Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE');
		$method = $_SERVER['REQUEST_METHOD'];
		if($method == 'OPTIONS') {
			die();
		}
 		
        parent::__construct();

        // Configure limits on our controller methods
        // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
      //  $this->methods['users_get']['limit'] = 500; // 500 requests per hour per user/key
       // $this->methods['users_post']['limit'] = 100; // 100 requests per hour per user/key
       // $this->methods['users_delete']['limit'] = 50; // 50 requests per hour per user/key
    }

    public function loginp_post()
    {  
		$nome = $this->post('nome');
        $this->load->model("M_usuario", "usuario");
        $consulta =   $this->usuario->login( strtoupper($nome),$this->post('senha'),$this->post('id'));
        //$this->response($consulta->result());
		$this->response($consulta);
    }

	public function buscarParametrop_post()
    {  
		
        $this->load->model("M_parametro", "parametro");
        $consulta =   $this->parametro->buscarParametroEmpresa($this->post('id'));
        //$this->response($consulta->result());
		$this->response($consulta);
    }    
	
	public function credenciarDescontop_post()
    {  
		$codigoUsuario = $this->post('codigoUsuario');
        $this->load->model("M_usuario", "usuario");
        $consulta = $this->usuario->credenciarDesconto(($codigoUsuario), $this->post('senha'), $this->post('id'), $this->post('percentualDesc'));
		$this->response($consulta);
    }

	public function buscarResumop_post(){
		$this->load->model("M_vendas", "vendas");
		$id = ($this->post('id'));
		$ano = ($this->post('data')['year']);
		$mes = ($this->post('data')['month']);
		$dia = ($this->post('data')['day']);
		
		$dia1 = str_pad($dia, 2, "0", STR_PAD_LEFT);
		$mes1 = str_pad($mes, 2, "0", STR_PAD_LEFT);
		
		$consulta = $this->vendas->buscarVendas($id, $dia1, $mes1, $ano);
		$this->response($consulta);
	}

	public function buscarLojasp_post(){
		$this->load->model("M_lojas", "lojas");
		$id = ($this->post('id'));
		$consulta = $this->lojas->buscarEstoqueIndividual($id);
		$this->response($consulta);
		
	}

	public function buscarEstoquep_post(){
		$this->load->model("M_estoque", "estoque");
		$id = ($this->post('id'));
		$codigo = ($this->post('codigo'));
		$parametro = ($this->post('parametro'));
		
		$consulta = $this->estoque->buscarEstoqueIndividual($id, strtoupper($codigo), $parametro);
		$this->response($consulta);
		
	}

	public function buscarParametroEmpresa_post(){
		$this->load->model("M_estoque", "estoque");
		$id = ($this->post('id'));
		$consulta = $this->estoque->buscarParametroEmpresa($id);
		$this->response($consulta);
	}

	public function buscarContasAbertasp_post(){
		$this->load->model("M_financeiro", "financeiro");
		$id = ($this->post('id'));
		$data_inicial = ($this->post('data_inicial'));
		$data_final = ($this->post('data_final'));
		
		$dia_ini = $this->ajustarDatas($data_inicial['day'], $data_inicial['month'], $data_inicial['year']);
		$dia_fim = $this->ajustarDatas($data_final['day'], $data_final['month'], $data_final['year']);
		
		$consulta = $this->financeiro->buscarContasAbertas($id, $dia_ini, $dia_fim);
		$this->response($consulta);
	}
	
	public function ajustarDatas($dia, $mes, $ano){
		
		$dia1 = str_pad($dia, 2, "0", STR_PAD_LEFT);
		$mes1 = str_pad($mes, 2, "0", STR_PAD_LEFT);
		
		return $dia1 . "." . $mes1 . "." . $ano; 
	}
	
    public function consultaClienteCpf_post() {  
        $this->load->model("M_cliente", "cliente");
        $consulta =  $this->cliente->consultaClienteCpf($this->post('codigo'),$this->post('id'));
        $this->response($consulta);
    }

    public function saveCliente_post() {  
       	$this->load->model("M_cliente", "cliente");
       	$idCliente = $this->cliente->insertCliente($this->post('idConexao'), $this->post('cpf'), $this->post('nome'), $this->post('cep'),
    	$this->post('uf'), $this->post('cidade'), $this->post('endereco'), $this->post('bairro'), $this->post('telefone'), $this->post('email'),
 		$this->post('ibge') );
 		
 		$this->load->model("M_vendas", "vendas");
 		$this->vendas->atualizarCabecalho($this->post('idConexao'), $this->post('pedido'), "", "", "", "", "", $idCliente);
		$this->vendas->atualizarContasReceber($this->post('idConexao'), $this->post('pedido'), "", $idCliente);
       	
       	$this->response($this->post('cpf'));
    }

    public function atualizarVendaCliente_post() {  
 		$this->load->model("M_vendas", "vendas");
 		$this->vendas->atualizarCabecalho($this->post('id'), $this->post('pedido'), "", "", "", "", "", $this->post('codclie'));
		$this->vendas->atualizarContasReceber($this->post('id'), $this->post('pedido'), "", $this->post('codclie'));
       	$this->response(true);
    }

    public function atualizarVendaFinalizarPedido_post() {  
    	$dataAtual = (date('Y-m-d'));
 		$this->load->model("M_vendas", "vendas");
 		
 		$this->vendas->atualizarVendedorTpgCondPedido($this->post('id'), $this->post('pedido'), $this->post('condicaoPagamento'), $this->post('tipoDocumento'), $this->post('observacao'), $this->post('numeroBoleto'), $this->post('vendedor'));
		
		$pedi01 = $this->vendas->verificarExistenciaCabecalho($this->post('id'), $this->post('pedido'));
 		

 		$this->load->model("M_condicao", "condicao");
    	$condicaoPagto = $this->condicao->buscarCondicaoPagamento($this->post('id'), $this->post('condicaoPagamento'));
    	$valorParcela = $pedi01['bruto'] / $condicaoPagto[0]['PAGTO'];
    	$arr = array();
    	if($condicaoPagto[0]['PAGTO'] > 16){
			$this->response(true);
    	} else {
    		$this->vendas->deletarContasReceber($this->post('pedido'), $this->post('loja'), $this->post('id'));
	    	for($i = 0; $i < $condicaoPagto[0]['PAGTO']; $i++) {
	    		$cont = 'INT'.(+1+$i);
	        	$this->vendas->inserirContasReceberFinal($this->post('id'), $this->post('pedido'), (+1+$i), $dataAtual, $this->post('loja'), $valorParcela, $pedi01['codforn'], $this->post('tipoDocumento'), date('Y-m-d', strtotime('+'.$condicaoPagto[0][$cont].' days', strtotime((date('Y-m-d'))))));
	    	}
	       	$this->response(true);	
    	}
    	
    }

    public function deletarPedido_post(){
    	$this->load->model("M_vendas", "vendas");
    	$this->vendas->deletarPedido($this->post('pedido'), $this->post('id'));
    	$this->response(true);
    }

    public function consultarVendedoresPorLoja_post() {  
 		$this->load->model("M_vendedor", "vendedor");
 		$vendedores = $this->vendedor->consultaVendedoresPorLoja($this->post('id'), $this->post('loja'));
       	$this->response($vendedores);
    }

    public function consultaTipoDeDocumento_post() {  
 		$this->load->model("M_tipoDocumento", "tipoDocumento");
 		$tipoDocumento = $this->tipoDocumento->buscarTipoDocumento($this->post('id'));
       	$this->response($tipoDocumento);
    }

    public function consultarCondicaoPagto_post() {  
 		$this->load->model("M_condicao", "condicao");
 		$condicaoPagto = $this->condicao->buscarCondicaoPagamento($this->post('id'), "");
       	$this->response($condicaoPagto);
    }

    public function consultarMovimentacaoItensPedido_post() {  
        $this->load->model("M_vendas", "vendas");
        $consulta =  $this->vendas->buscarMovimentacaoItens($this->post('pedido'), $this->post('id'));
        $this->response($consulta);
    }

	public function deletarItensPedido_post() {  
        $this->load->model("M_vendas", "vendas");
        $valorPedido = $this->vendas->verificarExistenciaCabecalho($this->post('id'), $this->post('pedido'));
        
        $quantidade = $this->post('qtdade');
        $preco = $this->post('preco');
        $valorBruto = $valorPedido['bruto'];

        $consulta =  $this->vendas->deletarItens($this->post('pedido'), $this->post('codprod'), 
        	$this->post('numero'), $this->post('id'), $this->post('qtdade'), $this->post('preco') );

        $this->vendas->atualizarCabecalho($this->post('id'), $this->post('pedido'), $valorBruto-($preco * $quantidade), "", "", "", "", "");
		$this->vendas->atualizarContasReceber($this->post('id'), $this->post('pedido'), $valorBruto-($preco * $quantidade), "");
        
        $this->response($consulta);
    }
    

    public function inserirItensp_post(){
    	$dataAtual = (date('d-m-Y'));
		$this->load->model("M_vendas", "vendas");
		$jsonObj = $this->post();
		$idConexao = $jsonObj[0]['id'];
		$arrayItens = array();
		$data = array();
		$pedido = "";
		for($i = 0; $i < count($jsonObj); $i++) {
        	$arrayItens = $jsonObj[$i];
    	}
		for($i = 0; $i < count($arrayItens); $i++) {
			$this->load->model("M_util","util");
			if($arrayItens[$i]['pedido'] == ""){
				$pedido = $this->util->geraNumeroPedido($dataAtual, $arrayItens[$i]['loja'], $idConexao);	
			} else {
				$pedido = $arrayItens[$i]['pedido'];
			}
			$data = array(
				'CODIGO' => $arrayItens[$i]['codprod'],
				'CUSTO' => $arrayItens[$i]['custo'],
				'NUMERO' => $arrayItens[$i]['numero'],
				'PRECO_BRUTO' => $arrayItens[$i]['preco_bruto'],
				'QTDADE' => $arrayItens[$i]['quantidade'],
				'QTDADESOL' => $arrayItens[$i]['quantidade'],
				'PRECO' => $arrayItens[$i]['venda'],
				'LOJA' => $arrayItens[$i]['loja'],
				'DTA_PED' => $dataAtual,
				'TIPO' => '1',
				'PEDIDO' => $pedido
			);
			$this->vendas->inserirItens($idConexao, $pedido, date('Y-m-d'), $data['LOJA'], $data['PRECO'], $data['CODIGO'], $data['NUMERO'], $data['QTDADE'], $data['CUSTO'], $data['PRECO_BRUTO']);

	    }
	    $returnConsulta = $this->vendas->verificarExistenciaCabecalho($idConexao, $pedido);
	    if($returnConsulta == true){
			$this->vendas->atualizarCabecalho($idConexao, $pedido, $returnConsulta['bruto']+($data['PRECO'] * $data['QTDADE']), "", "", "", "", "");
			$this->vendas->atualizarContasReceber($idConexao, $pedido, $returnConsulta['bruto']+($data['PRECO'] * $data['QTDADE']), "");
	    } else {
	    	$this->vendas->inserirCabecalho($idConexao, $pedido, date('Y-m-d'), $data['LOJA'], $data['PRECO']*$data['QTDADE']);
	    	$this->vendas->inserirContasReceber($idConexao, $pedido, date('Y-m-d'), $data['LOJA'], $data['PRECO']*$data['QTDADE']);
	    }
		$this->response($pedido);
	}




	public function salvarBalanco_post()
    {  
        $this->load->model("M_balanco", "balanco");
        $jsonObj = $this->post();
        $idConexao = $jsonObj[0]['id'];
        $arrayItens = array();
        $arrayItensNovo;
		$data = array();
		for($i = 0; $i < count($jsonObj); $i++) {
        	$arrayItens = $jsonObj[$i];
    	}
    	$pedido = $arrayItens[0]['pedido'];
    	$uuid = $arrayItens[0]['uuid'];
    	$loja = $arrayItens[0]['loja'];
		
		$result2 = $this->balanco->procurarBalanco($pedido, $uuid, $idConexao, $loja);
		if($result2 == 'false'){
			for($i = 0; $i < count($arrayItens); $i++) {
				$data = array(
				        'CODIGO' => strtoupper($arrayItens[$i]['codigo']),
				        'QUANTIDADE' => $arrayItens[$i]['quantidade'],
				        'DATA' => $arrayItens[$i]['data'],
				        'LOJA' => $arrayItens[$i]['loja'],
				        'QTDA_CODPROD' => $arrayItens[$i]['pedido'],
				        'QTDA_NUMERO' => $arrayItens[$i]['uuid']
				);
				$result = $this->balanco->insertBalanco($data, $idConexao);
	    	}
	    	$this->response('Processado com sucesso!');	
		} else {
			$this->response('Balanco ja foi enviado!');	
		}
		
        //$this->response($data);
        
    }    
    //frmCadastroDeVendedores

    

	public function consultarVendedores_post() {  
		$return = $this->consultarPermissaoModulo($this->post('id'), $this->post('usuario'), 'frmCadastroDeVendedores');
		if($return == true){
			$this->load->model("M_vendedor", "vendedor");
	        $consulta = $this->vendedor->procurarVendedores($this->post('id'),$this->post('parametro'),strtoupper($this->post('codigo')));
	        $this->response($consulta);
		} else {
			$this->response(false);
		}
		//$this->response($return);     
        
    }

    public function consultarPermissaoModulo($id, $usuario, $modulo) {  
        $this->load->model("M_modulo", "modulo");
        $consulta = $this->modulo->consultarPermissaoUsuario($id, $usuario, $modulo);
        return $consulta;
    }

    public function atualizarLojaVendedores_post() {  
        $this->load->model("m_vendedor", "vendedor");
        $consulta = $this->vendedor->atualizarLojaVendedor($this->post('id'), $this->post('vendedor'), $this->post('lojavend'));
        $this->response($consulta);
    }

    

    public function login_get()
    {  
         $this->load->model("m_usuario", "usuario");
         $consulta =   $this->usuario->login($this->get('nome'),$this->get('senha'),$this->get('id'));
 
        $this->response($consulta->result());
    }

    public function conexao_get()
    {
       
        $this->load->model("m_conexoes", "conexoes");
        $consulta = $this->conexoes->getConnection($this->get('id'));
 
        $this->response($consulta->result());
    }

 

}
