<?php
if (!defined('BASEPATH')) {
    exit('No direct script access allowed');
}

class M_cliente extends CI_Model {

    public function buscarClienteCCA($nome){

        if($nome != ""){
            $sql = " select subcartao, dias from scar01 s where s.subcartao = ? ";
            $query = $this->db->query($sql, $nome );
            $a = "aaa";
        } else {
            $sql = " select subcartao, dias from scar01 s ";
            $query = $this->db->query($sql);
        }
                
        $arr = array();       
        foreach ($query->result_array() as $row)
        {
            $row['SUBCARTAO'] = utf8_encode($row['SUBCARTAO'] );            
            array_push($arr, $row );
        }
        return $arr;
    }

    public function  insertClienteCCA($nome, $percentual){        
        $this->db->set('SUBCARTAO', $nome);        
        $this->db->set('DIAS', $percentual);
        $this->db->insert('SCAR01');
        return true;
         
    }

    public function atualizarClienteCCA($nome, $percentual){
        $this->db->set('DIAS', $percentual);        
        $this->db->where('SUBCARTAO', $nome);
        $this->db->update('SCAR01');
        return true;
    }

        
    
    
    public function buscarClientes($nome, $vendedor){        
        $sql = " select codclie, nome, cgc, cpf,  cep, uf, cida, ende, bairro, tele, cod_uf, cod_cida, OBS8CAULY, 'N' as bloqueado from clie01 c  where 1=1 ";
        $sql .= " and c.vendedor = '".$vendedor."' ";
        if($nome != ""){        
        $sql .= " and not exists (select codclie from rece01 r where c.codclie = r.codclie and r.dta_venci < (select data from Pr_DateTimeParaDate('now')) and r.dta_pagto is null) and c.nome like '%".$nome."%' or c.cgc = '".$nome."' or c.cpf = '".$nome."'
            group by codclie, nome, cgc, cpf,  cep, uf, cida, ende, bairro, tele, cod_uf, cod_cida, OBS8CAULY ";
        }
        
        $sql .= " order by nome ";
        $query = $this->db->query($sql);        
        $arr = array();
        foreach ($query->result_array() as $row)
        {
            
            $row['NOME'] = utf8_encode($row['NOME'] );
            $row['CIDA'] = utf8_encode($row['CIDA'] );
            $row['ENDE'] = utf8_encode($row['ENDE'] );
            $row['BAIRRO'] = utf8_encode($row['BAIRRO'] );
            $row['OBS8CAULY'] = utf8_encode($row['OBS8CAULY'] );
            $row['TELE'] = utf8_encode($row['TELE'] );
            array_push($arr, $row );
                
        }
        return $arr;
    }

    public function atualizarContasClientes($dataAtual, $vendedor){
        $sql = "select c.codclie from Rece01 r inner join Clie01 c on r.codclie = c.codclie where r.dta_Pagto is null and r.dta_Venci < (select data from Pr_DateTimeParaDate('now')) and c.vendedor = '".$vendedor."' group by 1 ";
        $query = $this->db->query($sql, array($dataAtual));             
        return $query->result_array();
    }

    public function consultaClienteCpf($cpf) {
        
        $sql = " select codclie, nome, ende, bairro, cida, uf, cep, tele, nasc, cpf, cgc from clie01 c ";
            if(strlen($cpf) == 11){
                $sql .= "where c.cpf = ? ";
                $query = $this->db->query($sql, $cpf );
            } else if(strlen($cpf) == 14) {
                $sql .= "where c.cgc = ? "; 
                $query = $this->db->query($sql, $cpf );
            } else {
                $sql .= "where c.codclie = '000001' ";  
                $query = $this->db->query($sql, $cpf );
            }
        $resultado = array();
        array_push($resultado, $query->row());
        return $resultado;
    }
    
    public function  insertCliente($cpf, $nome, $cep, $uf, $cidade, $endereco, $bairro, $telefone, $email, $ibge, $vendedor){
        $dataAtual = (date('d.m.Y'));        
        $sqlGen = " select GEN_ID(GEN_CLIE01, 1) FROM RDB\$DATABASE ";
        $query = $this->db->query($sqlGen);
        $codclie = $query->row();
        $this->load->model("M_util", "util");
        $cod = $this->util->zeroEsquerda($codclie->GEN_ID,6);

        $this->db->set('CODCLIE', $cod);
        $this->db->set('NOME', substr(strtoupper($nome),0,48));
        if(strlen($cpf) == 14){
            $this->db->set('CGC', $cpf);
        } else {
            $this->db->set('CPF', $cpf);
        }
        $this->db->set('ENDE', substr(strtoupper($endereco),0,50));
        $this->db->set('BAIRRO', substr(strtoupper($bairro), 0, 20));
        $this->db->set('COD_CIDA', $ibge);
        $this->db->set('VENDEDOR', $vendedor);      
        $this->db->set('COD_UF', substr($ibge,0,2));
        $this->db->set('CIDA', (strtoupper($cidade)));
        $this->db->set('UF', strtoupper($uf));
        $this->db->set('CEP', ($cep));
        $this->db->set('FANTASIA', substr(strtoupper($nome),0,40));
        $this->db->set('SIGLA', "A");
        $this->db->set('CODAREA', "001");
        $this->db->set('CODGCLI', "001");
        $this->db->set('DATA_CAD', $dataAtual);
        $this->db->set('TELE', $telefone);
        $this->db->set('OBS8CAULY', strtoupper($email));
        $this->db->insert('CLIE01');
        return $cod;
         
    }
}


?>