<?php
if (!defined('BASEPATH')) {
    exit('No direct script access allowed');
}

class M_vendas extends CI_Model {
	
	public function inserirCabecalho($pedido, $data, $loja, $valor, $codclie, $condicao, $vendedor, $obs, $area, $tpg, $tipo ){
    $b = $this->db;
    $b->set('PEDIDO', $pedido);
    $b->set('VENDEDOR', $vendedor);
    $b->set('BRUTO', $valor);
    $b->set('DESCONTO', 0);
    $b->set('DATA', $data);
    $b->set('CONDICAO', $condicao);
    $b->set('CODFORN', $codclie);
    $b->set('DTA_PROC', $data);
    $b->set('DTA_FATU', $data);
    $b->set('CODACES', "A");
    $b->set('TPVENDA', "X");
    $b->set('OBS', $obs);
    $b->set('VL_FATU', $valor);
    $b->set('PAGTOS', "-1");
    $b->set('LOJA', $loja);
    $b->set('TIPO', $tipo);
    $b->set('CODAREA', $area);
    $b->set('TPG', $tpg);
    $b->set('DTA_PRODUCAO', $data);
    $b->set('OBSP2', "Venda=Versao mobile 1.0 ionic");
    $b->insert('PEDI01');
    return true;
  }

  public function inserirItens($pedido, $data, $loja, $valor, $codprod, $numero, $qtdade, $custo, $preco_bruto){
    $b = $this->db;

    $sql = "select * from MOVI01 where pedido = ? and codprod = ? and numero = ? ";
    $query = $b->query($sql, array($pedido, $codprod, $numero));
    $row = $query->result_array();
    if ($row != []){
      //$return = array("pedido" => $row->PEDIDO, "bruto" => $row->BRUTO);
      $b->set('QTDADE', (float) $row[0]['QTDADE']+ (float)$qtdade);
      $b->set('QTDADESOL', (float) $row[0]['QTDADE']+ (float)$qtdade);
      
      $b->where('PEDIDO', $pedido);
      $b->where('CODPROD', $codprod);
      $b->where('NUMERO', $numero);

      $b->update('MOVI01');
      
    } else {
      //return false;
      $b->set('PEDIDO', $pedido);
      $b->set('LOJA', $loja);
      $b->set('DTA_PED', $data);
      $b->set('CODPROD', $codprod);
      $b->set('NUMERO', $numero);
      $b->set('TIPO', "1");
      // round(1.95583, 2);
      $b->set('PRECO', round($valor, 2));
      $b->set('QTDADE', $qtdade);
      $b->set('QTDADESOL', $qtdade);
      $b->set('PCUSTO', $custo);
      $b->set('PRECO_BRUTO', round($preco_bruto, 2));  
      $b->insert('MOVI01');
       
    }
    return true;
  }

  public function deletarItens($pedido, $codprod, $numero){
    $b = $this->db;
    $b->delete('MOVI01', array('CODPROD' => $codprod, 'NUMERO' => $numero, 'PEDIDO' => $pedido));
    return true;  
  }

  public function atualizarPedi01($pedido, $bruto, $condicao, $codarea, $obs, $tpg){    
    $b = $this->db;
    $b->set('CONDICAO', $condicao);  
    $b->set('CODAREA', $codarea);  
    $b->set('TPG', $tpg);  
    $b->set('BRUTO', round($bruto, 2));  
    $b->set('VL_FATU', round($bruto, 2));  
    $b->set('OBS', strtoupper($obs));    
    $b->where('PEDIDO', $pedido);  
    $b->update('PEDI01');
    return true;
  }

  public function inserirContasReceberFinal($pedido, $parcela, $data, $loja, $valor, $codclie, $dataVencimento, $tpg){
    $b = $this->db;
    $b->set('PEDIDO', $pedido);
    $this->load->model("M_util", "util");
    $b->set('PARCELA', $this->util->zeroEsquerda($parcela, 3));
    $b->set('CODCLIE', $codclie);
    $b->set('TIPODOC', $tpg);
    $b->set('LOJA', $loja);
    $b->set('VL_DEVI', $valor);
    $b->set('DATA', $data);
    $b->set('DTA_VENCI', $dataVencimento);
    $b->insert('RECE01');
    return true;
  }

  public function vendasPorCliente($data_inicial, $data_final, $vendedor){
    $sql = "
          select nome,cgc,sum(qt_venda) as qt_venda,
          sum(vl_venda) as vl_venda, sum(qt_devolucao) as qt_devolucao,
          sum(vl_devolucao) as vl_devolucao, sum(qt_bonificacao) as qt_bonificacao,
          sum(vl_bonificacao) as vl_bonificacao,
          sum(qt_venda) - sum(qt_devolucao) + sum(qt_bonificacao) as qt_total,
          sum(vl_venda) - sum(vl_devolucao) + sum(vl_bonificacao) as vl_total
          from (
          select
                               p.DATA,c.nome,c.cgc,
                               (case when m.tipo in ('1','B') and p.codarea <> '998' then m.qtdade else 0 end) as qt_venda,
                               (case when m.tipo in ('1','B') and p.codarea <> '998' then m.qtdade*m.preco else 0 end) as vl_venda,

                               (case when m.tipo = ('5') then m.qtdade else 0 end) as qt_devolucao,
                               (case when m.tipo = ('5') then m.qtdade*m.preco else 0 end) as vl_devolucao,

                               (case when m.tipo in ('1','B') and p.codarea = '998' then m.qtdade else 0 end) as qt_bonificacao,
                               (case when m.tipo in ('1','B') and p.codarea = '998' then m.qtdade*m.preco else 0 end) as vl_bonificacao
                           from pedi01 p                            
                           inner join clie01 c on p.codforn = c.codclie
                           inner join movi01 m on p.pedido = m.pedido
                           where p.loja in ('01')
                           and p.data between ? and ?
                           and (p.tipo in ('1','5'))
                           and p.vendedor = ?                           
          )
          group by 1,2
          order by vl_total desc
    ";    
    $query = $this->db->query($sql, array($data_inicial, $data_final, $vendedor));            
    return $query->result_array();
  }
}


?>