function textArea(){
	tinymce.init({
		selector: "textarea#elm1",
		theme: "modern",
		plugins: [
			"advlist autolink autosave link image lists charmap print preview hr anchor pagebreak spellchecker",
			"searchreplace wordcount visualblocks visualchars code fullscreen insertdatetime media nonbreaking",
			"save table contextmenu directionality emoticons template textcolor paste fullpage textcolor colorpicker codesample"
		],
		external_plugins: {
			//"moxiemanager": "/moxiemanager-php/plugin.js"
		},
		content_css: "css/development.css",
		add_unload_trigger: false,
		autosave_ask_before_unload: false,

		toolbar1: "save newdocument fullpage | bold italic underline strikethrough | alignleft aligncenter alignright alignjustify | styleselect formatselect fontselect fontsizeselect",
		toolbar2: "cut copy paste pastetext | searchreplace | bullist numlist | outdent indent blockquote | undo redo | link unlink anchor image media help code | insertdatetime preview | forecolor backcolor",
		toolbar3: "table | hr removeformat | subscript superscript | charmap emoticons | print fullscreen | ltr rtl | spellchecker | visualchars visualblocks nonbreaking template pagebreak restoredraft | insertfile insertimage codesample",
		menubar: false,
		toolbar_items_size: 'small',

		style_formats: [
			{title: 'Bold text', inline: 'b'},
			{title: 'Red text', inline: 'span', styles: {color: '#ff0000'}},
			{title: 'Red header', block: 'h1', styles: {color: '#ff0000'}},
			{title: 'Example 1', inline: 'span', classes: 'example1'},
			{title: 'Example 2', inline: 'span', classes: 'example2'},
			{title: 'Table styles'},
			{title: 'Table row 1', selector: 'tr', classes: 'tablerow1'}
		],

		templates: [
			{title: 'My template 1', description: 'Some fancy template 1', content: 'My html'},
			{title: 'My template 2', description: 'Some fancy template 2', url: 'development.html'}
		],

	    spellchecker_callback: function(method, data, success) {
			if (method == "spellcheck") {
				var words = data.match(this.getWordCharPattern());
				var suggestions = {};

				for (var i = 0; i < words.length; i++) {
					suggestions[words[i]] = ["First", "second"];
				}

				success({words: suggestions, dictionary: true});
			}

			if (method == "addToDictionary") {
				success();
			}
		}
	});
}


function organizaData(data){
 var ano = data.substring(0,4);
 var mes = data.substring(5,7);
 var dia = data.substring(8,10).replace(",","");
 var dataCompleta = dia+"/"+mes+"/"+ano;
 
 return dataCompleta;
}

function formatDate(arg){
	var date = new Date(arg);
	var day   = date.getDate();
	var month = date.getMonth()+1;
	var year  = date.getFullYear();
	return "{0}/{1}/{2}".format(lpad(day,2,0),lpad(month,2,0),year);
}

String.prototype.format = String.prototype.f = function() {
	var s = this,
        i = arguments.length;

	while (i--) {
        	s = s.replace(new RegExp('\\{' + i + '\\}', 'gm'), arguments[i]);
	}
	return s;
};

function isImg(url) {
	var img = new Image();
	img.src = url;
	return img.height != 0;
}

Date.prototype.addDays = function(days){
    var dat = new Date(this.valueOf());
    dat.setDate(dat.getDate() + days);
    return "{0}/{1}/{2}".format(dat.getDate(),(dat.getMonth()+1),dat.getFullYear());
/*
 * var dat = new Date('2010/12/20'); //exemplo de uso alert(dat.addDays(5));
 */
};

String.prototype.replaceAll = function(token, newtoken) { 
	var string = this;
	while (string.indexOf(token) != -1) {
		string = string.replace(token, newtoken);
	}
	return string;
};

function msgErro(msg,timeOut){
	$("#msgErro").css("display","inline-block");
	$("#msgErro").html("<strong>Aten&ccedil;&atilde;o!</strong> "+msg+".");
	setTimeout(function(){
		$('#msgErro').hide();
	},timeOut);
};

function clearnbsp(selector){
	$(selector).each(function(){
		var $this = $(this);
    	$this.html($this.html().replace(/&nbsp;/g, ""));
    });
};

function geraNumeroPedido(dateCurrent){
	var dia, mes, ano;
	var JDDataInicial, JDDataFinal, ggg, A, aux, s;
	dia = eval('01');
	mes = eval('01');
	ano = eval(dateCurrent.split("/")[2]);
	with(Math){
		ano <= 1585 ? ggg = 0 : ggg = 1;
		JDDataInicial = -1 * floor(7 * (floor(( mes + 9) / 12) + ano) / 4);
		((mes - 9) < 0) ? s = -1 : s = 1;
		A = (abs(mes-9));
		aux = floor(ano + s * floor(A / 7));
		aux = -1 * floor((floor(aux / 100) + 1) *3 / 4);
		JDDataInicial = JDDataInicial + floor(275 * mes / 9) + dia + (ggg + aux);
		JDDataInicial = JDDataInicial + 1721027 + 2 * ggg + 367 * ano - 0.5;
		JDDataInicial = JDDataInicial - (12/24);
	}
/* -------------------------------------------------------- */	
	dia = eval(dateCurrent.split("/")[0]);
	mes = eval(dateCurrent.split("/")[1]);
	ano = eval(dateCurrent.split("/")[2]);
	with(Math){
		ano <= 1585 ? ggg = 0 : ggg = 1;
		JDDataFinal = -1 * floor(7 * (floor(( mes + 9) / 12) + ano) / 4);
		((mes - 9) < 0) ? s = -1 : s = 1;
		A = (abs(mes-9));
		aux = floor(ano + s * floor(A / 7));
		aux = -1 * floor((floor(aux / 100) + 1) *3 / 4);
		JDDataFinal = JDDataFinal + floor(275 * mes / 9) + dia + (ggg + aux);
		JDDataFinal = JDDataFinal + 1721027 + 2 * ggg + 367 * ano - 0.5;
		JDDataFinal = JDDataFinal - (12/24);
	}
	return (dateCurrent.substring(9,10)+lpad(((JDDataFinal - JDDataInicial)+1),3,0));
};

function lpad(string, pad, arg){
	var newString = "";
	for(var i = string.toString().length; i < pad; i++){
		newString += arg.toString();
	}
	return newString + string;
} ;

function retornarDiaSemana(data){
	var dias = new Array(
			'domingo','segunda-feira','terca-feira','quarta-feira','quinta-feira','sexta-feira','sabado'
	);
	var data2 = new Date(parseInt(data.substring(6,10)), parseInt(data.substring(3,5))-1, parseInt(data.substring(0,2)));
	return dias[data2.getDay()];
}

$(".data").datepicker({
	dateFormat: 'dd/mm/yy',
	    dayNames: ['Domingo','Segunda','Terça','Quarta','Quinta','Sexta','Sábado'],
	dayNamesMin: ['D','S','T','Q','Q','S','S','D'],
	dayNamesShort: ['Dom','Seg','Ter','Qua','Qui','Sex','Sáb','Dom'],
	monthNames: ['Janeiro','Fevereiro','Março','Abril','Maio','Junho','Julho','Agosto','Setembro','Outubro','Novembro','Dezembro'],
	monthNamesShort: ['Jan','Fev','Mar','Abr','Mai','Jun','Jul','Ago','Set','Out','Nov','Dez'],
	nextText: 'Próximo',
	prevText: 'Anterior',
	//showOn: "button",
	//buttonImage: "../css/images/calendar.png",
	buttonImageOnly: false	
});

function graficoResumoMensalAnalitico(dados,tituloCentro,tituloLateral){
	var serie = [];
	var categoria = [];
	dados.sort(function(a,b){
		var dateA = a.data.split('/').reverse().join('');
		var dateB = b.data.split('/').reverse().join('');
		return dateA - dateB;
	});
	for(var i = 0; i < dados.length; i++){
			serie[i]= [dados[i].valor];
			categoria[i]= [dados[i].data]+'';
	}
	$('#container').highcharts({
		chart: {
			type: 'column',
		},
		title: {
			useHTML: true,
			text: tituloCentro,
			x:-20
		},
		subtitle: {
			useHTML: true,
            text: 'Gr&aacute;fico Gerado pelo Valor Bruto',
            x: -20
        },
		xAxis: {
			categories: categoria,
			labels: {
				rotation: -60,
				align: 'right',
				style: {
					fontSize: '12px',
					fontFamily: '"Helvetica Neue",Helvetica,Arial,sans-serif'
				}
			}
		},
		yAxis: {
			labels:{
				formatter: function(){
					return mascara((this.value)+'');
				}
			},
			tickInterval: 3000,
			minorTickInterval: 'auto',
			title: {
				text: tituloLateral
			}
		},
		legend: {
			enabled: false
		},
		tooltip: {
			formatter: function(){
				return 'Valor vendido: '+mascara((this.y)+'');
			},
		},
		series: [{
			data: 
			       serie, color: '#95B8E0',
			
			dataLabels: {
				formatter: function(){
					return mascara((this.y)+'');
					},
				enabled: true,
				rotation: -90,
				color: '#000000',
				align: 'right',
				x: 4,
				y: -35,
				style: {
					fontWeight: 'bold',
					visibility: 'inherit',
					fontSize: '12px',
					fontFamily: '"Helvetica Neue",Helvetica,Arial,sans-serif'
				}
			}
		}],
		credits: {
			enabled: false
		},
		navigation: {
            buttonOptions: {
                enabled: false
            }
        }
	});
};
function graficoPizza(valor) {
	var dinheiro = (valor[0]/valor[8])*100;
	var tef = (valor[1]/valor[8])*100;
	var pos = (valor[2]/valor[8])*100;
	var cheque = (valor[3]/valor[8])*100;
	var boleto = (valor[4]/valor[8])*100;
	var vales = (valor[5]/valor[8])*100;
	var outros = (valor[6]/valor[8])*100;
	var valeDesp = (valor[7]/valor[8])*100;
        $('#container').highcharts({
            chart: {
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
            title: {
            	useHTML: true,
                text: 'Gr&aacute;fico Resumo Mensal - Sint&eacute;tico',
                x: -20
            },
            subtitle: {
    			useHTML: true,
                text: 'Os vales e despesas representam '+ valeDesp.toFixed(2)+' % do faturamento.',
                x: -20
            },
            tooltip: {
        	    pointFormat: '{series.name}: <b>{point.y:.2f}%</b>'
            },
            plotOptions: {
                pie: {
                	point:{
                		events: {
                			legendItemClick: function() {
                				return false;
                			}
                		}
                	},
                	showInLegend: true,
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                    	enabled: true,
                        color: '#000000',
                        connectorColor: '#000000',
                        format: '<b>{point.name}</b>: {point.y:.2f} %'
                    }
                },
            },
            series: [{
                type: 'pie',
                ignoreHiddenPoint: true,
                name: 'Browser share',
                data: [
                    ['TEF',       tef],
                    ['POS',       pos],
                    {   name:'Dinheiro',
                    	y: dinheiro,
                    	sliced: true,
                    	selected: true
                    },
                    ['Cheque',    cheque],
                    ['Boleto',    boleto],
                    ['Vales',     vales],
                    ['Outros',    outros]
                   // ['Vale/Desp', valeDesp]
                ]
            }],
            credits: {
    			enabled: false
    		},
    		navigation: {
                buttonOptions: {
                    enabled: false
                }
            }
    });
};
function validaModulo(){
	var session = "";
	while (session.indexOf(', ') != -1){
	    session = session.replace(', ', '","');
	}
	while (session.indexOf(': ') != -1){
	    session = session.replace(': ', '":"');
	}
	while (session.indexOf(',"Modulo') != -1){
	    session = session.replace(',"Modulo', '},{"Modulo');
	}
	session = '[{"'+session+'"}]';
	session = $.parseJSON(session);
		$.each(session, function(idx, val){
			$.each($(".modulo"),function(i, v){
			if(val.Modulo == v.name && val.Entrar == "S"){
				if(($(this)[0].baseURI == $(this)[0].href)){
					 if(val.Alterar == "S"){
						 $("#frm").find("input[name='alterar']").css("display","inline-block");
				 	 }else{
				 		 console.log("else");
					 	 $("#frm").find("input[name='alterar']").css("display","none");
				 	 }
					 if(val.Excluir == "S"){
						 $("#frm").find("input[name='excluir']").css("display","inline-block");
						 $("#frm").find("button[name='excluir']").css("display","inline-block");
					 }else{
						 $("#frm").find("input[name='excluir']").css("display","none");
						 $("#frm").find("button[name='excluir']").css("display","none");
					 }
					 if(val.Incluir == "S"){
						 $("#frm").find("input[name='incluir']").css("display","inline-block");
						 $("#salvar").css("display","inline-block");
					 }else{
						 $("#frm").find("input[name='incluir']").css("display","none");
						 $("#salvar").css("display","none");
					 }
					 if(val.Pesquisar == "S"){
						 $("#frm").find("a[name='pesquisar']").css("display","inline-block");
						 $("#cancelar").css("display","inline-block");
					 }else{
						 $("#frm").find("a[name='pesquisar']").css("display","none");
						 $("#cancelar").css("display","none");
					 }
					 return false;
				}
		 }else{
			 if((val.Modulo == v.name) && (val.Entrar == "N")){
				 if(($(this)[0].baseURI == $(this)[0].href)){
					 if(val.Alterar == "S"){
						 $("#frm").find("input[name='alterar']").css("display","inline-block");
				 	 }else{
					 	 $("#frm").find("input[name='alterar']").css("display","none");
				 	 }
					 if(val.Excluir == "S"){
						 $("#frm").find("input[name='excluir']").css("display","inline-block");
						 $("#frm").find("button[name='excluir']").css("display","inline-block");
					 }else{
						 $("#frm").find("input[name='excluir']").css("display","none");
						 $("#frm").find("button[name='excluir']").css("display","none");
					 }
					 if(val.Incluir == "S"){
						 $("#frm").find("input[name='incluir']").css("display","inline-block");
						 $("#salvar").css("display","inline-block");
					 }else{
						 $("#frm").find("input[name='incluir']").css("display","none");
						 $("#salvar").css("display","none");
					 }
					 if(val.Pesquisar == "S"){
						 $("#frm").find("a[name='pesquisar']").css("display","inline-block");
						 $("#cancelar").css("display","inline-block");
					 }else{
						 $("#frm").find("a[name='pesquisar']").css("display","none");
						 $("#cancelar").css("display","none");
					 }
					 $(this).css("display","none");
					 return false;
				 }
				$(this).css("display","none");
			}
		  }
		});
	});
};
function dateCurrent(){
	var data = new Date();
	var dia = data.getDate();
	var mes = data.getMonth()+1;
	var ano = data.getFullYear();
	return "{0}/{1}/{2}".format(lpad(dia,2,0),lpad(mes,2,0),ano);
};
function horaCurrent(){
	var data = new Date();
	var hora = data.getHours();
	var minuto = data.getMinutes();
	return "{0}:{1}".format(lpad(hora,2,0),lpad(minuto,2,0));
};
function validarCPF(cpf) {
    cpf = cpf.replace(/[^\d]+/g,'');
    if (cpf == '' 			 ||
    	cpf.length != 11     || 
        cpf == "00000000000" || 
        cpf == "11111111111" || 
        cpf == "22222222222" || 
        cpf == "33333333333" || 
        cpf == "44444444444" || 
        cpf == "55555555555" || 
        cpf == "66666666666" || 
        cpf == "77777777777" || 
        cpf == "88888888888" || 
        cpf == "99999999999")
        return false;
    soma = 0;
    pos  = 10;
    for (var i = 0; i < 9; i ++){
    	soma += parseInt(cpf.substring(i,(i+1))) * pos--;
    }
    resultado = (soma % 11) == 10 || (soma % 11) == 11 ? 0 : (11 - (soma % 11)); 
    if ((resultado+'') != cpf.substring((cpf.length - 2),(cpf.length - 1))){
    	return false;
    }
    soma = 0;
    pos = 11;
    for (var i = 0; i < 10; i ++){
    	soma += parseInt(cpf.substring(i,(i+1))) * pos--;
    }
    resultado = (soma % 11) == 10 || (soma % 11) == 11 ? 0 : (11 - (soma % 11));
    if ((resultado+'') != cpf.substring((cpf.length - 1),(cpf.length))){
    	return false;
    }
    return true;
};

function validarCpf1(cpf){
	var Soma; 
	var Resto; 
	Soma = 0; 
	 cpf = cpf.replace(/[^\d]+/g,'');
		if (cpf == '' 			 ||
	    	cpf.length != 11     || 
	        cpf == "00000000000" || 
	        cpf == "11111111111" || 
	        cpf == "22222222222" || 
	        cpf == "33333333333" || 
	        cpf == "44444444444" || 
	        cpf == "55555555555" || 
	        cpf == "66666666666" || 
	        cpf == "77777777777" || 
	        cpf == "88888888888" || 
	        cpf == "99999999999")
	        return false;
	
		for (i=1; i<=9; i++) Soma = Soma + parseInt(cpf.substring(i-1, i)) * (11 - i); 
		Resto = (Soma * 10) % 11;
	
	if ((Resto == 10) || (Resto == 11)) Resto = 0; 
	if (Resto != parseInt(cpf.substring(9, 10)) ) return false; 
	
		Soma = 0; 
	for (i = 1; i <= 10; i++) Soma = Soma + parseInt(cpf.substring(i-1, i)) * (12 - i); 
	Resto = (Soma * 10) % 11;
	
	if ((Resto == 10) || (Resto == 11)) Resto = 0; 
	if (Resto != parseInt(cpf.substring(10, 11) ) ) return false; 
	return true;
};
function validarCNPJ(cnpj) {
	 
    cnpj = cnpj.replace(/[^\d]+/g,'');
    if( cnpj == '' 			 	 ||	 
    	cnpj.length != 14 		 ||
    	cnpj == "00000000000000" || 
        cnpj == "11111111111111" || 
        cnpj == "22222222222222" || 
        cnpj == "33333333333333" || 
        cnpj == "44444444444444" || 
        cnpj == "55555555555555" || 
        cnpj == "66666666666666" || 
        cnpj == "77777777777777" || 
        cnpj == "88888888888888" || 
        cnpj == "99999999999999"){
    	return false;
    }
    tamanho = (cnpj.length - 2);
    numeros = cnpj.substring(0,tamanho);
    digitos = cnpj.substring(tamanho);
    soma = 0;
    pos = 5;
    for (var i = 0; i <= tamanho ; i++) {
      soma += (numeros.substring(i,(i+1)) * pos--);
      if (pos < 2)
            pos = 9;
    }
    resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
    if ((resultado+'') != digitos.substring(0,(digitos.length - 1))){
        return false;
    }
    tamanho = tamanho + 1;
    numeros = cnpj.substring(0,tamanho);
    soma = 0;
    pos = 6;
    for (var i = 0; i <= tamanho ; i++) {
        soma += (numeros.substring(i,(i+1)) * pos--);
        if (pos < 2)
              pos = 9;
    }
    resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
    if ((resultado+'') != digitos.substring((digitos.length - 1),digitos.length)){
          return false;
    }
    return true;
};

function isEmail(email){
	var regex = /^([a-zA-Z0-9_\.\-\+])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
	 if(!regex.test(email)) {
         return false;
      }else{
         return true;
      }
};
function dateMinus(date,minus){
	var data = date.split("/");
	var newDate = new Date(parseInt(data[2], 10),parseInt(data[1], 10) - 1,parseInt(data[0], 10));
	newDate.setDate(newDate.getDate() - minus);
	return "{0}/{1}/{2}".format(lpad(newDate.getDate(),2,0).slice(-2),lpad((newDate.getMonth()+1),2,0).slice(-2),newDate.getFullYear());
};
function ordenaData(obj,index){
	obj.sort(function(a,b){
		var dateA = a[index].split('/').reverse().join(''),dateB = b[index].split('/').reverse().join('');
		return dateA - dateB;
	});
};
function mascara(valor){
	var string = "";
	var menos = "";
	var aux = valor ;
	if(valor.indexOf(".") === -1){  
		aux += ".00";
	}
	if(valor.indexOf("-") === 0){
		menos = "-";
		aux = aux.replace("-","");
	}
	var inteira = aux.substring(0,aux.indexOf("."));
	var decimal = ((aux-inteira)*100).toFixed(0);
	if(decimal == 100){
		decimal = "00";
		inteira = (Math.floor(inteira)+1)+'';
	  }
	if(decimal.length === 1){
		decimal = "0"+decimal;
	}
	var int = Math.floor((inteira.length)/3);
	var tam = ((inteira.length)-(int*3));
	var ar = [];
	var cont = 0;
	if(tam > 0){    
	  ar[cont] =inteira.substring(0,tam);
	  cont++;  
	  inteira = inteira.substring(tam,(inteira.length));
	}
	while(inteira){
	  ar[cont] = inteira.substring(0,3);
	  cont++;  
	  inteira = inteira.substring(3,(inteira.length));
	}
	for(var i = 0; i < cont; i++){
	  if(string !== ""){  
	    string+=".";
	  }
	  string += ar[i];
	}
	string += ","+decimal;  
	return menos+string;
};
function mascaraCpf(cpf){
	if(cpf.length < 11){
		return false;
	}
	return "{0}.{1}.{2}-{3}".format(cpf.substring(0,3),cpf.substring(3,6),cpf.substring(6,9),cpf.substring(9,11));
};
function mascaraCnpj(cnpj){
	if(cnpj.length < 14){
		return false;
	}
	return "{0}.{1}.{2}/{3}-{4}".format(cnpj.substring(0,2),cnpj.substring(2,5),cnpj.substring(5,8),cnpj.substring(8,12),cnpj.substring(12,14));
};
function lastDayOfMonth(Month, Year){
    return(new Date((new Date(Month+1,Year,1))-1)).getDate();
};

function inserirMascaraTelefone(telefone){
if (telefone.length == 10 ) {
	$(".telefone").mask("(99)9999-9999");
} else if(telefone.length == 11){
	$(".telefone").mask("(99)99999-9999");
}else if(telefone.length > 11){
	$(".telefone").mask("(99)99999-9999");
}

};




// pronto
// http://splatoperator.com/2011/10/add-stable-merge-sort-to-array-and-jquery-prototypes/
(function () {
	  'use strict';
	  // Add stable merge sort method to Array prototype
	  if (!Array.mergeSort) {
	    Array.prototype.mergeSort = function (compare) {
	      var length = this.length,
	        middle = Math.floor(length / 2);
	      // define default comparison function if none is defined
	      if (!compare) {
	        compare = function (left, right) {
	          if (left  <  right) {
	            return -1;
	          } else if (left === right) {
	            return 0;
	          } else {
	            return 1;
	          }
	        };
	      }
	      if (length < 2) {
	        return this;
	      }
	      function merge(left, right, compare) {
	        var result = [];
	        while (left.length > 0 || right.length > 0) {
	          if (left.length > 0 && right.length > 0) {
	            if (compare(left[0], right[0]) <= 0) {
	              result.push(left[0]);
	              left = left.slice(1);
	            } else {
	              result.push(right[0]);
	              right = right.slice(1);
	            }
	          } else if (left.length > 0) {
	            result.push(left[0]);
	            left = left.slice(1);
	          } else if (right.length > 0) {
	            result.push(right[0]);
	            right = right.slice(1);
	          }
	        }
	        return result;
	      }
	      return merge(
	        this.slice(0, middle).mergeSort(compare),
	        this.slice(middle, length).mergeSort(compare),
	        compare
	      );
	    };
	  }
	  // Add merge sort to jQuery if it's present
	  if (window.jQuery !== undefined) {
	    jQuery.fn.mergeSort = function (compare) {
	      return jQuery(Array.prototype.mergeSort.call(this, compare));
	    };
	    jQuery.mergeSort = function (array, compare) {
	      return Array.prototype.mergeSort.call(array, compare);
	    };
	  }
	}());